### Third party modules and libraries used by Nelson

Nelson includes code from the following projects, which have their own licenses:

- Qt 5.x Cross-platform application framework

> <https://www.qt.io>

> <https://www.qt.io/licensing/>

- Boost C++ Libraries

> <http://www.boost.org>

> <http://www.boost.org/users/license.html>

- Eigen

a C++ template library for linear algebra: matrices, vectors, numerical solvers, and related algorithms:

> <http://eigen.tuxfamily.org>

> <http://eigen.tuxfamily.org/index.php?title=Main_Page#License>

- BLAS

Basic Linear Algebra Subprograms

> <http://www.netlib.org/blas/>

> <http://www.netlib.org/blas/#_licensing>

- LAPACK

Linear Algebra PACKage

> <http://www.netlib.org/lapack/> > <http://www.netlib.org/lapack/#_licensing>

- OpenBLAS

OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.

> <http://www.openblas.net/>

- fftw3.h

FFTW header

> <https://raw.githubusercontent.com/FFTW/fftw3/master/api/fftw3.h>

> MIT license

- MKL

The Fastest and Most-UsedMath Library for Intel-Based Systems

> <https://software.intel.com/en-us/mkl>

> <https://software.intel.com/en-us/license/intel-simplified-software-license>

- HDF5

High-performance data management and storage suite

> <https://www.hdfgroup.org/solutions/hdf5/>

> <https://support.hdfgroup.org/ftp/HDF5/releases/COPYING>

- MATIO

MAT file I/O library

> <https://github.com/tbeu/matio>

> <https://github.com/tbeu/matio/blob/master/COPYING> (BSD)

- F2C

f2c is a program to convert Fortran 77 to C code, developed at Bell Laboratories.

> <http://www.netlib.org/f2c/>

> NetLib license (free software)

- MS-MPI

Microsoft MPI (MS-MPI) is a Microsoft implementation of the Message Passing Interface standard for developing and running parallel applications on the Windows platform.

> <https://msdn.microsoft.com/en-us/library/bb524831(v=vs.85).aspx>

- Open-mpi

> <https://www.open-mpi.org/>

> <https://www.open-mpi.org/community/license.php>

- Libxml2

the XML C parser and toolkit developed for the Gnome project

> <http://www.xmlsoft.org/>

> <https://git.gnome.org/browse/libxml2/tree/Copyright>

- libffi

A portable foreign-function interface library

> <http://sourceware.org/libffi>

> <https://github.com/libffi/libffi/blob/master/LICENSE>

- zlib

A Massively Spiffy Yet Delicately Unobtrusive Compression Library

> <http://www.zlib.net/>

> <http://www.zlib.net/zlib_license.html>

- minizip2

Fork of the popular zip manipulation library found in the zlib distribution.

> <https://github.com/nmoinvaz/minizip>

> <https://github.com/nmoinvaz/minizip/blob/master/LICENSE>

- Hoedown

Standards compliant, fast, secure markdown processing library in C

> <https://github.com/hoedown/hoedown>

> <https://github.com/hoedown/hoedown/blob/master/LICENSE>

- Linenoise

A small self-contained alternative to readline and libedit

> <https://github.com/antirez/linenoise>

> <https://github.com/antirez/linenoise/blob/master/LICENSE>

- ICU

International Components for Unicode

> <http://site.icu-project.org/>

> <http://www.unicode.org/copyright.html#License>

- gettext

> <https://www.gnu.org/software/gettext/>

> <https://www.gnu.org/software/gettext/manual/html_node/Licenses.html>

- highlight.js

> <https://highlightjs.org/>

> <https://github.com/isagalaev/highlight.js/blob/master/LICENSE>

- dtl

The Diff Template Library written by C++

> <https://github.com/cubicdaiya/dtl>

> <https://github.com/cubicdaiya/dtl/blob/master/COPYING>

- TANGO icons

> <http://tango.freedesktop.org/Tango_Desktop_Project>

> Public Domain

- Jmsn

> <https://github.com/zserge/jsmn>

> <https://github.com/zserge/jsmn/blob/master/LICENSE>
> MIT license

- cpp-json-prettify

> <https://github.com/Borisas/cpp-json-prettify>

> <https://github.com/Borisas/cpp-json-prettify/blob/master/license.txt>
> MIT license

- Portaudio

PortAudio is a free, cross-platform, open-source, audio I/O library

> <http://www.portaudio.com/> > <http://www.portaudio.com/license.html>
> MIT license

- libsndfile

Libsndfile is a C library for reading and writing files containing sampled sound.

> <http://www.mega-nerd.com/libsndfile/>

> <https://github.com/erikd/libsndfile/blob/master/COPYING>
> LGPL

- taglib

TagLib Audio Meta-Data Library

> <http://taglib.org/>

> <https://github.com/taglib/taglib/blob/master/COPYING.LGPL>
> LGPL

- Socket.IO C++ Client

C++11 implementation of Socket.IO client

> <https://github.com/socketio/socket.io-client-cpp>

> <https://github.com/llamerada-jp/socket.io-cpp-client-sample>

> <https://github.com/socketio/socket.io-client-cpp/blob/master/LICENSE> (MIT)

- rapidJSON

A fast JSON parser/generator for C++ with both SAX/DOM style API

> <https://github.com/Tencent/rapidjson>

> <https://github.com/Tencent/rapidjson/blob/master/license.txt> (MIT)

- websocketpp

C++ websocket client/server library

> <http://www.zaphoyd.com/websocketpp>

> <https://github.com/zaphoyd/websocketpp/blob/master/COPYING>

- libcurl

libcurl - the multiprotocol file transfer library

> <https://curl.haxx.se/libcurl/>

> <https://curl.haxx.se/docs/copyright.html>

- libgit2

libgit2 is a portable, pure C implementation of the Git core methods.

> <https://libgit2.org/>

> <https://github.com/libgit2/libgit2/blob/master/COPYING> GPL with LINKING EXCEPTION

- semver.c

Semantic version v2.0 parser and render written in ANSI C with zero dependencies.

> <https://github.com/h2non/semver.c>

> <https://github.com/h2non/semver.c/blob/master/LICENSE> MIT license

- asio

Asio C++ Library

> <http://think-async.com/Asio/>

> <https://github.com/chriskohlhoff/asio/blob/master/asio/COPYING> (Boost 1.0)

- fifo_map

a FIFO-ordered associative container for C++

> <https://github.com/nlohmann/fifo_map>

> <https://github.com/nlohmann/fifo_map/blob/master/LICENSE.MIT> MIT license

- picoSHA2

PicoSHA2 - a C++ SHA256 hash generator

> <https://github.com/okdshin/PicoSHA2>

> <https://github.com/okdshin/PicoSHA2/blob/master/LICENSE> MIT license

- fmtlib

A modern formatting library

> <https://fmt.dev/latest/index.html>

> <https://github.com/fmtlib/fmt/blob/master/LICENSE.rst> MIT license

- fast_float

fast_float number parsing library: 4x faster than strtod

> <https://github.com/fastfloat/fast_float>

> <https://github.com/fastfloat/fast_float/blob/main/LICENSE-MIT> MIT license

- Hack-Regular font

A typeface designed for source code

> <https://sourcefoundry.org/hack/>

> <https://github.com/source-foundry/Hack/blob/master/LICENSE.md> MIT license

- Combinear Theme

A typeface designed for source code

> <https://qss-stock.devsecstudio.com/templates/components/components2/combinear/Combinear.rar>

> MIT license

- thread-pool

A C++17 Thread Pool for High-Performance Scientific Computing

> <https://github.com/bshoshany/thread-pool>

> <https://github.com/bshoshany/thread-pool/blob/master/LICENSE.txt> MIT license
