%=============================================================================
% Copyright (c) 2017 Allan CORNET (Nelson)
%=============================================================================
% This file is part of the Nelson.
%=============================================================================
% LICENCE_BLOCK_BEGIN
% SPDX-License-Identifier: LGPL-3.0-or-later
% LICENCE_BLOCK_END
%=============================================================================
% <-- Issue URL -->
% https://github.com/Nelson-numerical-software/nelson/issues/139
% <-- Short Description -->
% fix(1e10) returned a wrong value
%=============================================================================
V = 1e10;
R = fix(V);
REF = V;
assert_isequal(R, REF);
%=============================================================================
V = 1e32;
R = fix(V);
REF = V;
assert_isequal(R, REF);
%=============================================================================
V = 1e333;
R = fix(V);
REF = inf;
assert_isequal(R, REF);
%=============================================================================
V = 1e-433;
R = fix(V);
REF = 0;
assert_isequal(R, REF);
%=============================================================================
V = [];
R = fix(V);
REF = [];
assert_isequal(R, REF);
%=============================================================================
