//=============================================================================
// Copyright (c) 2016-present Allan CORNET (Nelson)
//=============================================================================
// This file is part of the Nelson.
//=============================================================================
// LICENCE_BLOCK_BEGIN
// SPDX-License-Identifier: LGPL-3.0-or-later
// LICENCE_BLOCK_END
//=============================================================================
#include "ticBuiltin.hpp"
#include "Error.hpp"
#include "TicToc.hpp"
//=============================================================================
using namespace Nelson;
//=============================================================================
ArrayOfVector
Nelson::TimeGateway::ticBuiltin(Evaluator* eval, int nLhs, const ArrayOfVector& argIn)
{
    ArrayOfVector retval;
    nargincheck(argIn, 0, 0);
    nargoutcheck(nLhs, 0, 1);
    Tic(eval);
    if (nLhs == 1) {
        retval << ArrayOf::uint64Constructor(eval->TimerValue);
        eval->TimerValue = static_cast<uint64>(0);
    }
    return retval;
}
//=============================================================================
