//=============================================================================
// Copyright (c) 2016-present Allan CORNET (Nelson)
//=============================================================================
// This file is part of the Nelson.
//=============================================================================
// LICENCE_BLOCK_BEGIN
// SPDX-License-Identifier: LGPL-3.0-or-later
// LICENCE_BLOCK_END
//=============================================================================
#include "IsLeapYear.hpp"
//=============================================================================
namespace Nelson {
//=============================================================================
bool
IsLeapYear(int year)
{
    if (year < 0) {
        return false;
    }
    /* Check if the year is divisible by 4 or is divisible by 400 */
    return ((year % 4 == 0 && year % 100 != 0) || (year % 400 == 0));
}
//=============================================================================
} // namespace Nelson
//=============================================================================
